package com.integratedideas.rupam.mqtt;

import android.content.pm.ActivityInfo;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Looper;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import org.eclipse.paho.client.mqttv3.IMqttToken;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.math.BigDecimal;
import java.util.Date;

public class MainActivity extends AppCompatActivity  implements OnClickListener , View.OnTouchListener,View.OnLongClickListener,SensorEventListener{

    enum GESTURES{LEFT,RIGHT,CENTER,NONE};
    GESTURES currentGesture=GESTURES.NONE;
    GESTURES prevGesture=GESTURES.NONE;

    Button b,b2,b3,b4;
    TextView tv2;
    String channel="";
     SensorManager sensorManager;
    private final String TAG = "MQTTClient";

    String sAddress = "iot.eclipse.org";
    String sUserName = null;
    String sPassword = null;
    String sDestination = null;
    String sMessage = null;

    String topic        = "rupam/data";
    String content      = "FORWARD";
    int qos             = 2;
    //String broker       = "tcp://test.mosquitto.org:1883";
    String broker       = "tcp://192.168.1.103:1883";
    String clientId     = "RUPAM_DAS";
    MemoryPersistence persistence = new MemoryPersistence();
    MqttClient sampleClient;
    MqttConnectOptions connOpts;
    EditText edServer;
    Button btnConnect;
    EditText edChannel;
    public static boolean isConnected=false;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        b = (Button)findViewById(R.id.button);
        b2=(Button)findViewById(R.id.button2);
        b3=(Button)findViewById(R.id.button3);
        b4=(Button)findViewById(R.id.button4);
      btnConnect=(Button)findViewById(R.id.button5);
        edServer=(EditText)findViewById(R.id.editText);;
        edChannel=(EditText)findViewById(R.id.edChannel);
        topic=edChannel.getText().toString().trim();

        btnConnect.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                broker="tcp://"+edServer.getText().toString().trim()+":1883";
                topic=edChannel.getText().toString().trim();
                ConnectionClass con=new ConnectionClass();
                con.execute();
            }
        });
      //  b.setOnClickListener(this);
        b.setOnTouchListener(this);
        b2.setOnTouchListener(this);        //b.setOnLongClickListener(this);
        b3.setOnTouchListener(this);        //b.setOnLongClickListener(this);
        b4.setOnTouchListener(this);        //b.setOnLongClickListener(this);
        tv2=(TextView)findViewById(R.id.textView2);

        sensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);

        sensorManager.registerListener(this, sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER), sensorManager.SENSOR_DELAY_UI);

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        //Connect();
    }
    String s="Conntected";
    public class ConnectionClass extends  AsyncTask<String, String, String>
    {
        Exception exc = null;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }
        @Override protected String doInBackground(String... params) {
            try
            {
                if (Looper.myLooper()==null)
                    Looper.prepare();
                sampleClient = new MqttClient(broker, clientId, persistence);

                //    sampleClient=new MqttClient(broker,clientId);
                connOpts = new MqttConnectOptions();
                connOpts.setCleanSession(true);
                IMqttToken imt=sampleClient.connectWithResult(connOpts);

                Log.d("MQTT MODULE.....","....DONE..."+sampleClient.getServerURI()+"--"+imt.getResponse().getPayload());


                if(sampleClient.isConnected()) {
                    return "CONNECTED";
                }
                else
                {
                    return "Connection Failed.....";
                }

            }
            catch(Exception ex )
            {

                Log.d("MQTT MODULE", "CONNECTion FAILED " + ex.getMessage() + " broker: " + broker + " clientId " + clientId);

                return "FAILED "+ex.getMessage();
            }
            // return null;
        }

        @Override protected void onPostExecute(String result) {
            super.onPostExecute(result);

            if(result!= null)
            {
                if(result.equals("CONNECTED"))
                {
                    isConnected=true;
                }
                else
                {
                    isConnected=false;
                }
                tv2.setText(result);
                Toast.makeText(MainActivity.this, result, Toast.LENGTH_LONG).show();
                // setContentView(result);
            }
        }
    }
    void Send(String content)
    {
        final String data=content;
      // isConnected =sampleClient.isConnected();
        AsyncTask.execute(new Runnable()
        {
            @Override
            public void run()
            {

                try
                {
                    if(isConnected)
                    {
                        MqttMessage message = new MqttMessage(data.getBytes());
                        message.setQos(qos);
                        sampleClient.publish(topic, message);
                    }

                    Log.d("MQTT MODULE",data+" SENT");
                }
                catch(Exception ex)
                {

                }
                //TODO your background code
            }


        });
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View v) {
       tv2.setText((new Date()).toString());
    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {

        Button b=(Button)v;
        switch (event.getAction() & MotionEvent.ACTION_MASK) {

            case MotionEvent.ACTION_DOWN:
                v.setPressed(true);
                // Start action ...
                tv2.setText("ENTERED:"+b.getText()+"-" + (new Date()).toString());
                Send(b.getText().toString());
                break;
            case MotionEvent.ACTION_UP:
            case MotionEvent.ACTION_OUTSIDE:
            case MotionEvent.ACTION_CANCEL:
                v.setPressed(false);
                // Stop action ...
                tv2.setText("LEFT:" + b.getText() + "-" + (new Date()).toString());
               if(b.getText().toString().trim().equals("LEFT")||b.getText().toString().trim().equals("RIGHT"))
                   Send("NO");
                else
                Send("STOP");
                break;
            case MotionEvent.ACTION_POINTER_DOWN:
                break;
            case MotionEvent.ACTION_POINTER_UP:
                break;
            case MotionEvent.ACTION_MOVE:
                break;
        }

        return true;
    }

    @Override
    public boolean onLongClick(View v) {
      //  tv2.setText("LC==>"+(new Date()).toString());
        return false;
    }
    public  float Round(float d, int decimalPlace) {
        BigDecimal bd = new BigDecimal(Float.toString(d));
        bd = bd.setScale(decimalPlace, BigDecimal.ROUND_HALF_UP);
        return bd.floatValue();
    }
float prevX=-1,prevY=-1,prevZ=-1;
    float DX=0;
    long lastUpdate = System.currentTimeMillis();
    int WAIT=300;
    @Override
    public void onSensorChanged(SensorEvent event) {

        float[] values = event.values;



        // Movement
        float x = Round(values[0],1);
        float y = Round(values[1],1);
        float z = Round(values[2],1);
        long curTime = System.currentTimeMillis();
        if ((curTime - lastUpdate) > 100)
        {
            long diffTime = (curTime - lastUpdate);
            lastUpdate = curTime;

            float speed = Math.abs(x + y + z - prevX - prevY - prevZ) / diffTime * 10000;
        /*float accelationSquareRoot = (x * x + y * y + z * z)
                / (SensorManager.AXIS_X * SensorManager.AXIS_X);*/
            //Log.d("sensor", "shake detected w/ speed: " + speed);

            if (speed > 1200)
            {
                Send("JUMP");
            }
        }
        if(prevX!=-1)
        {

            float diffX=x-prevX;
            float diffY=y-prevY;
            float diffz=z-prevZ;

            DX=DX+diffX;

            prevX=x;
            prevZ=y;
            prevZ=z;
        }
        else
        {
            prevX=x;
            prevY=y;
            prevZ=z;
        }

    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int accuracy) {

    }


    private void toast(String message)
    {
        Toast.makeText(this, message, Toast.LENGTH_LONG).show();
    }
}
