#include <Wire.h>
#include <WiFi.h>
#include "Adafruit_TMP006.h"
#include "wifi.h"
#include "http.h"
#include "time.h"

#define WLAN_PUB_SSID ""
#define WLAN_KEY_CODE ""
#define TMP_SNSR_HOST "raspberrypi"
#define TMP_SNSR_PORT 3000
#define TMP_SNSR_PATH "/temperature"

Adafruit_TMP006 tmp006(0x41);

void setup() {
  Serial.begin(9600);
  connectWifi(WLAN_PUB_SSID, WLAN_KEY_CODE);
  tmp006.begin();
  tmp006.wake();
  setCurrentTime();
}

void loop() {
  char receive_msg_buffer[1024];
  char send_msg_buffer[128];

  while (true) {
    delay(2000);
    float value = tmp006.readObjTempC();
    sprintf(send_msg_buffer, "%lf", value);
    Serial.println(send_msg_buffer);
    httpPostRequest(TMP_SNSR_HOST, TMP_SNSR_PORT, TMP_SNSR_PATH, send_msg_buffer, receive_msg_buffer);
  }
}
