﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Threading;
using WatcherCommons.Interfaces;
using ATModemProtocol.Properties;

namespace ATModemProtocol
{
    public class ATModemAlarmChannel : IAlarmChannel
    {
        private string _port = "";
        private int _baudrate = 9600;
        private int _delay = 2000;
        private int _ring = 2000;
        private string _number = "";
        public string ConnectionString
        {
            get
            {
                return string.Join(";", new string[] { "port=" + _port, "baudrate=" + _baudrate.ToString(), "initdelay=" + _delay.ToString(), "number=" + _number, "ringduration=" + _ring.ToString()});
            }
            set
            {
                foreach (string s in value.Split(';'))
                {
                    string[] p = s.Split('=');
                    if (string.Compare(p[0], "port", true) == 0)
                    {
                        _port = p[1];
                    }
                    else if (string.Compare(p[0], "baudrate", true) == 0)
                    {
                        _baudrate = int.Parse(p[1]);
                    }
                    else if (string.Compare(p[0], "initdelay", true) == 0)
                    {
                        _baudrate = int.Parse(p[1]);
                    }
                    else if (string.Compare(p[0], "ringduration", true) == 0)
                    {
                        _ring = int.Parse(p[1]);
                    }
                    else if (string.Compare(p[0], "number", true) == 0)
                    {
                        _number = p[1];
                    }
                }
            }
        }
        public string MessageText { get; set; }
        public void Initialice()
        {
        }
        public void SendAlarm()
        {
            using (SerialPort p = new SerialPort(_port))
            {
                p.Open();                
                p.BaudRate = _baudrate;                
                Thread.Sleep(_delay);
                string[] numbers = _number.Split(',');
                foreach (string n in numbers)
                {
                    p.WriteLine("ATD" + n + ";\n\r");
                    Thread.Sleep(_ring);
                    p.WriteLine("ATH\n\r");
                    Thread.Sleep(_delay);
                }                
                p.Close();
            }
        }
        public override string ToString()
        {
            return Resources.ID_PROTOCOL;
        }
    }
}
