﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using Microsoft.Lync.Model;
using Microsoft.Lync.Model.Conversation;
using Microsoft.Lync.Model.Extensibility;
using WatcherCommons.Interfaces;
using LyncProtocol.Properties;

namespace LyncProtocol
{
    public class LyncAlarmChannel : IAlarmChannel
    {
        private LyncClient _lyncClient = null;
        private Automation _lyncAutomation = null;

        public LyncAlarmChannel()
        {
        }
        public string ConnectionString { get; set; }
        public string MessageText { get; set; }
        public void Initialice()
        {
        }
        public void SendAlarm()
        {
            //Start the conversation
            _lyncAutomation = LyncClient.GetAutomation();
            _lyncClient = LyncClient.GetClient();
            ConversationManager conversationManager = _lyncClient.ConversationManager;
            conversationManager.ConversationAdded += new EventHandler<ConversationManagerEventArgs>(conversationManager_ConversationAdded);
            Conversation conversation = conversationManager.AddConversation();
        }
        public override string ToString()
        {
            return Resources.ID_PROTOCOL;
        }
        private void SendMessageCallback(IAsyncResult ar)
        {
            InstantMessageModality imModality = (InstantMessageModality)ar.AsyncState;

            try
            {
                imModality.EndSendMessage(ar);
            }
            catch 
            {                
            }
        }
        void conversationManager_ConversationAdded(object sender, ConversationManagerEventArgs e)
        {
            e.Conversation.ParticipantAdded += new EventHandler<ParticipantCollectionChangedEventArgs>(Conversation_ParticipantAdded);
            foreach (string recep in ConnectionString.Split(';'))
            {
                e.Conversation.AddParticipant(_lyncClient.ContactManager.GetContactByUri(recep));
            }
        }

        void Conversation_ParticipantAdded(object sender, ParticipantCollectionChangedEventArgs e)
        {
            // add event handlers for modalities of participants other than self participant:
            if (e.Participant.IsSelf == false)
            {
                if (((Conversation)sender).Modalities.ContainsKey(ModalityTypes.InstantMessage))
                {
                    ((InstantMessageModality)e.Participant.Modalities[ModalityTypes.InstantMessage]).InstantMessageReceived += new EventHandler<MessageSentEventArgs>(ConversationTest_InstantMessageReceived);
                    ((InstantMessageModality)e.Participant.Modalities[ModalityTypes.InstantMessage]).IsTypingChanged += new EventHandler<IsTypingChangedEventArgs>(ConversationTest_IsTypingChanged);
                }
                Conversation conversation = (Conversation)sender;

                InstantMessageModality imModality = (InstantMessageModality)conversation.Modalities[ModalityTypes.InstantMessage];

                IDictionary<InstantMessageContentType, string> textMessage = new Dictionary<InstantMessageContentType, string>();
                textMessage.Add(InstantMessageContentType.PlainText, MessageText);

                if (imModality.CanInvoke(ModalityAction.SendInstantMessage))
                {
                    IAsyncResult asyncResult = imModality.BeginSendMessage(
                        textMessage,
                        SendMessageCallback,
                        imModality);
                }
            }
        }
        private void ConversationTest_IsTypingChanged(object sender, IsTypingChangedEventArgs e)
        {

        }

        private void ConversationTest_InstantMessageReceived(object sender, MessageSentEventArgs e)
        {

        }

    }
}
