using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Net;
using Java.IO;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using System.Threading.Tasks;

[assembly: Xamarin.Forms.Dependency(typeof(TWClientApp.Droid.ImageManager_Droid))]
namespace TWClientApp.Droid
{
    public class ImageManager_Droid : IImageManager
    {
        public async Task SaveImage(string filename, byte[] data)
        {
            var dir = Android.OS.Environment.GetExternalStoragePublicDirectory(Android.OS.Environment.DirectoryDcim);
            var pictures = dir.AbsolutePath;
            string filePath = System.IO.Path.Combine(pictures, filename);
            try
            {
                System.IO.File.WriteAllBytes(filePath, data);
                //mediascan adds the saved image into the gallery
                var mediaScanIntent = new Intent(Intent.ActionMediaScannerScanFile);
                mediaScanIntent.SetData(Android.Net.Uri.FromFile(new File(filePath)));
                Xamarin.Forms.Forms.Context.SendBroadcast(mediaScanIntent);
            }
            catch (System.Exception e)
            {
                //System.Console.WriteLine(e.ToString());
            }
        }
    }
}