﻿using Windows.Storage;
using Windows.Foundation;
using System.Threading.Tasks;
using System;

[assembly: Xamarin.Forms.Dependency(typeof(TWClientApp.Windows.ImageManager_Windows))]
namespace TWClientApp.Windows
{
    public class ImageManager_Windows : IImageManager
    {
        public async Task SaveImage(string filename, byte[] data)
        {
            StorageFolder picturesLibrary = KnownFolders.PicturesLibrary;
            StorageFolder savedPicturesFolder = await picturesLibrary.CreateFolderAsync("TWClient", CreationCollisionOption.OpenIfExists);
            IAsyncOperation<StorageFile> imageFile = savedPicturesFolder.CreateFileAsync(filename, CreationCollisionOption.ReplaceExisting);
            await Task.Run((Action)delegate () { while (imageFile.Status == AsyncStatus.Started) ; });            
            IAsyncAction ia = FileIO.WriteBytesAsync(imageFile.GetResults(), data);
            await Task.Run((Action)delegate () { while (ia.Status == AsyncStatus.Started) ; });
        }
    }
}
