﻿using System;
using System.Configuration;


namespace ThiefWatcher.Configuration
{
    public class CameraData : ConfigurationElement
    {
        [ConfigurationProperty("id", IsRequired = true)]
        public string ID
        {
            get
            {
                return (string)(this["id"]);
            }
            set
            {
                this["id"] = value;
            }
        }
        [ConfigurationProperty("protocolName", IsRequired = true)]
        public string Protocol
        {
            get
            {
                return (string)(this["protocolName"]);
            }
            set
            {
                this["protocolName"] = value;
            }
        }
        [ConfigurationProperty("connectionStringName", IsRequired = true)]
        public string ConnectionString
        {
            get
            {
                return (string)(this["connectionStringName"]);
            }
            set
            {
                this["connectionStringName"] = value;
            }
        }
    }
    [ConfigurationCollection(typeof(CameraData))]
    public class CameraCollection : ConfigurationElementCollection
    {
        public void Add(CameraData data)
        {
            BaseAdd(data);
        }
        public override ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return ConfigurationElementCollectionType.BasicMapAlternate;
            }
        }
        protected override string ElementName
        {
            get
            {
                return "cameraData";
            }
        }
        protected override bool IsElementName(string elementName)
        {
            return elementName.Equals("cameraData", StringComparison.InvariantCultureIgnoreCase);
        }

        public override bool IsReadOnly()
        {
            return false;
        }

        protected override ConfigurationElement CreateNewElement()
        {
            return new CameraData();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((CameraData)(element)).ID;
        }

        public CameraData this[int idx]
        {
            get { return (CameraData)BaseGet(idx); }
        }
        public void RemoveAt(int ix)
        {
            BaseRemoveAt(ix);
        }
    }
    public class CamerasSection : ConfigurationSection
    {
        [ConfigurationProperty("cameras")]
        public CameraCollection Cameras
        {
            get
            {
                return (CameraCollection)(base["cameras"]);
            }
            set
            {
                base["cameras"] = value;
            }
        }
        public void RemoveAt(int ix)
        {
            Cameras.RemoveAt(ix);
        }
    }
}
