﻿using System.Windows.Forms;
using System.Drawing;
using VAPIXProtocol.Properties;

namespace VAPIXProtocol.Commands
{
    public class CmdAutofocus : CmdBase
    {
        private bool _auto = false;

        public CmdAutofocus(string p, TreeView tvparams)
            : base(p, tvparams)
        {
        }
        public override string GetCommandUri(Control container) 
        {
            string onoff = "off";
            foreach (Control c in container.Controls)
            {
                CheckBox cb = c as CheckBox;
                if (cb != null)
                {
                    onoff = cb.Checked ? "on" : "off";
                }
            }
            return "axis-cgi/com/ptz.cgi?" + Command + "=" + onoff;
        }
        public override void CreateUI(Control container)
        {
            base.CreateUI(container);
            CheckBox cb = new CheckBox();
            cb.AutoSize = true;
            cb.Text = UIResources.LAB_AUTOFOCUS;
            cb.Font = new Font("Arial", 9f, FontStyle.Bold);
            container.Controls.Add(cb);
            cb.Checked = _auto;
            cb.Left = 16;
            cb.Top = (container.Height - cb.Height) / 2;
        }
        protected override void ReadParams()
        {
            _auto = GetParamValue("PTZ.Support.S1.AutoFocus") == "yes";
        }
    }
}
