﻿using System.Drawing;
using System.Windows.Forms;
using VAPIXProtocol.Properties;

namespace VAPIXProtocol.Commands
{
    public class CmdContinuousFocusMove : CmdBase
    {
        public CmdContinuousFocusMove(string p, TreeView tvparams)
            : base(p, tvparams)
        {
        }
        public override string GetCommandUri(Control container) 
        {
            int focuss = 0;
            foreach (Control c in container.Controls)
            {
                NumericUpDown ud = c as NumericUpDown;
                if (ud != null)
                {
                    focuss = (int)ud.Value;
                }
            }
            return "axis-cgi/com/ptz.cgi?" + Command + "=" + focuss.ToString();
        }
        public override void CreateUI(Control container)
        {
            base.CreateUI(container);
            Label lbl = new Label();
            lbl.AutoSize = true;
            lbl.Text = UIResources.LAB_FOCUSCHG;
            lbl.Font = new Font("Arial", 9f, FontStyle.Bold);
            container.Controls.Add(lbl);
            lbl.Left = 16;
            lbl.Top = (container.Height - lbl.Height) / 2;
            NumericUpDown ud = new NumericUpDown();
            ud.Minimum = -100;
            ud.Maximum = 100;
            ud.Value = 0;
            container.Controls.Add(ud);
            ud.Left = lbl.Right + 4;
            ud.Top = (container.Height - ud.Height) / 2;
        }
        protected override void ReadParams()
        {
        }
    }
}
