﻿using System.Windows.Forms;
using System.Drawing;
using VAPIXProtocol.Properties;

namespace VAPIXProtocol.Commands
{
    public class CmdGotoServerPresetName : CmdBase
    {
        public CmdGotoServerPresetName(string p, TreeView tvparams)
            : base(p, tvparams)
        {
        }
        public override string GetCommandUri(Control container) 
        {
            string name = "";
            foreach (Control c in container.Controls)
            {
                TextBox tx = c as TextBox;
                if (tx != null)
                {
                    name = tx.Text;
                }
            }
            return "axis-cgi/com/ptz.cgi?" + Command + "=" + name;
        }
        public override void CreateUI(Control container)
        {
            base.CreateUI(container);
            Label lbl = new Label();
            lbl.AutoSize = true;
            lbl.Text = UIResources.LAB_NAME;
            lbl.Font = new Font("Arial", 9f, FontStyle.Bold);
            container.Controls.Add(lbl);
            lbl.Left = 16;
            lbl.Top = (container.Height - lbl.Height) / 2;
            TextBox txt = new TextBox();
            txt.Width = 100;
            container.Controls.Add(txt);
            txt.Left = lbl.Right + 4;
            txt.Top = (container.Height - txt.Height) / 2;
        }
        protected override void ReadParams()
        {
        }
    }
}
