﻿using System.Windows.Forms;
using System.Drawing;
using VAPIXProtocol.Properties;

namespace VAPIXProtocol.Commands
{
    public class CmdIrCutFilter : CmdBase
    {
       public CmdIrCutFilter(string p, TreeView tvparams)
            : base(p, tvparams)
        {
        }
       public override string GetCommandUri(Control container)
       {
           string ircf = "auto";
           foreach (Control c in container.Controls)
           {
               ComboBox cb = c as ComboBox;
               if (cb != null)
               {
                   ircf = cb.SelectedItem.ToString();
               }
           }
           return "axis-cgi/com/ptz.cgi?" + Command + "=" + ircf;
       }
       public override void CreateUI(Control container)
       {
           base.CreateUI(container);
           Label lbl = new Label();
           lbl.AutoSize = true;
           lbl.Text = UIResources.LAB_MOVE;
           lbl.Font = new Font("Arial", 9f, FontStyle.Bold);
           container.Controls.Add(lbl);
           lbl.Left = 16;
           lbl.Top = (container.Height - lbl.Height) / 2;
           ComboBox cb = new ComboBox();
           cb.DropDownStyle = ComboBoxStyle.DropDownList;
           cb.Items.Add("auto");
           cb.Items.Add("on");
           cb.Items.Add("off");
           container.Controls.Add(cb);
           cb.Left = lbl.Right + 4;
           cb.Top = (container.Height - cb.Height) / 2;
       }
       protected override void ReadParams()
       {
       }
    }
}
