﻿using System.Collections.Generic;
using System.IO;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace WatcherCommons.Data
{
    [DataContract]
    public class CameraInfo
    {
        public CameraInfo()
        {
        }
        public static List<CameraInfo> FromJSON(Stream s)
        {
            s.Position = 0;
            StreamReader rdr = new StreamReader(s);
            return JsonConvert.DeserializeObject<List<CameraInfo>>(rdr.ReadToEnd());
        }
        public static void ToJSON(Stream s, List<CameraInfo> ci)
        {
            s.Position = 0;
            string js = JsonConvert.SerializeObject(ci);
            StreamWriter wr = new StreamWriter(s);
            wr.Write(js);
            wr.Flush();
        }
        [DataMember]
        public string ID { get; set; }
        [DataMember]
        public bool Active { get; set; }
        [DataMember]
        public bool Photo { get; set; }
        [DataMember]
        public int Width { get; set; }
        [DataMember]
        public int Height { get; set; }
        [DataMember]
        public string ClientID { get; set; }
    }
}
