﻿using System.IO;
using System.Runtime.Serialization;
using Newtonsoft.Json;

namespace WatcherCommons.Data
{
    [DataContract]
    public class ControlCommand
    {
        public const int cmdGetCameraList = 1;
        public const int cmdStopAlarm = 2;
        public ControlCommand()
        {
        }
        public static ControlCommand FromJSON(Stream s)
        {
            s.Position = 0;
            StreamReader rdr = new StreamReader(s);
            string str = rdr.ReadToEnd();
            return JsonConvert.DeserializeObject<ControlCommand>(str);
        }
        public static void ToJSON(Stream s, ControlCommand cc)
        {
            s.Position = 0;
            string js = JsonConvert.SerializeObject(cc);
            StreamWriter wr = new StreamWriter(s);
            wr.Write(js);
            wr.Flush();
        }
        [DataMember]
        public int Command { get; set; }
        [DataMember]
        public string ClientID { get; set; }
    }
}
