﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WatcherCommons.Interfaces
{
    /// <summary>
    /// Protocol used to notify the posible presence of intruders
    /// </summary>
    public interface IAlarmChannel
    {
        /// <summary>
        /// String containing the protocol settings
        /// </summary>
        string ConnectionString { get; set; }
        /// <summary>
        /// Notification message to send to the clients
        /// </summary>
        string MessageText { get; set; }
        /// <summary>
        /// Here you can implement initialization tasks
        /// </summary>
        void Initialice();
        /// <summary>
        /// Call this method to notify an issue to the clients
        /// </summary>
        void SendAlarm();
    }
}
