﻿using System;

namespace WatcherCommons.Interfaces
{
    /// <summary>
    /// Interface with the camera settings dialog box
    /// </summary>
    public interface ICameraSetupManager
    {
        /// <summary>
        /// Event to notify changes on the frame size
        /// </summary>
        event EventHandler OnFrameSizeChanged;
        /// <summary>
        /// Force the dialog box to reload the camera settings
        /// </summary>
        void ReloadSettings();
    }
}
