﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WatcherCommons.Interfaces
{
    /// <summary>
    /// Protocol to inform the system for the presence of intruders
    /// </summary>
    public interface ITrigger
    {
        /// <summary>
        /// Event to link the application with the trigger
        /// </summary>
        event EventHandler OnTriggerFired;
        /// <summary>
        /// string with the protocol settings
        /// </summary>
        string ConnectionString { get; set; }
        /// <summary>
        /// Here you can perform initialization tasks
        /// </summary>
        void Initialize();
        /// <summary>
        /// Put the protocol in a running state
        /// </summary>
        void Start();
        /// <summary>
        /// Put the protocol in stopped state
        /// </summary>
        void Stop();
    }
}
