const helpers = require('./helpers.js');

function getFile (fn, cfg) {
  if (cfg) {
    return fn + '.' + cfg + '.json';
  } else {
    return fn + '.json';
  }
}

module.exports = {
  loadGlobal: function (config) {
    const baseConfig = helpers.readJson(getFile('config'));
    const specConfig = helpers.readJson(getFile('config', config));
    return Object.assign(baseConfig, specConfig);
  },
  loadUser: function (config) {
    return helpers.readJson(getFile('user', config));
  },
  saveUser: function (config, value) {
    helpers.writeJson(getFile('user', config), value);
  }
};