const fs = require('fs');

module.exports = {
  readJson: function (fileName) {
    try {
      return JSON.parse(fs.readFileSync(fileName, 'utf8'));
    } catch (e) {
      return {};
    }
  },
  writeJson: function (fileName, value) {
    const data = JSON.stringify(value);
    fs.writeFileSync(fileName, data, 'utf-8');  
  },
  getIntent: function (intents) {
    var intent = undefined;
    var score = 0.5;

    for (var i = intents.length; i--; ) {
      if (intents[i].score > score) {
        intent = intents[i].intent;
        score = intents[i].score;
      }
    }

    return intent;
  },
  getEntities: function (entities) {
    return entities.filter(function (entity) {
      return entity.score > 0.5;
    }).map(function (entity) {
      return {
        name: entity.entity,
        type: entity.type
      };
    });
  },
  getModule: function (module) {
    delete require.cache[require.resolve(module)];
    return require(module);
  }
};